Package org.jboss.resteasy.plugins.providers.jackson

## Class ResteasyJackson2Provider

- java.lang.Object
- - com.fasterxml.jackson.jaxrs.base.ProviderBase<com.fasterxml.jackson.jaxrs.json.JacksonJsonProvider,​com.fasterxml.jackson.databind.ObjectMapper,​com.fasterxml.jackson.jaxrs.json.JsonEndpointConfig,​com.fasterxml.jackson.jaxrs.json.JsonMapperConfigurator>
  - - com.fasterxml.jackson.jaxrs.json.JacksonJsonProvider
    - - com.fasterxml.jackson.jaxrs.json.JacksonJaxbJsonProvider
      - - org.jboss.resteasy.plugins.providers.jackson.ResteasyJackson2Provider

- All Implemented Interfaces:
    `com.fasterxml.jackson.core.Versioned`, `javax.ws.rs.ext.MessageBodyReader<Object>`, `javax.ws.rs.ext.MessageBodyWriter<Object>`, `AsyncBufferedMessageBodyWriter<Object>`, `AsyncMessageBodyWriter<Object>`

      @Provider
      @Consumes({"application/json","application/*+json","text/json"})
      @Produces({"application/json","application/*+json","text/json"})
      public class ResteasyJackson2Provider
      extends com.fasterxml.jackson.jaxrs.json.JacksonJaxbJsonProvider
      implements AsyncBufferedMessageBodyWriter<Object>

  Only different from Jackson one is *+json in @Produces/@Consumes
  Version:
    $Revision: 1 $
  Author:
    Bill Burke

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected ConcurrentHashMap<org.jboss.resteasy.plugins.providers.jackson.ResteasyJackson2Provider.ClassAnnotationKey,​com.fasterxml.jackson.jaxrs.json.JsonEndpointConfig>` | `_readers` |
    `protected ConcurrentHashMap<org.jboss.resteasy.plugins.providers.jackson.ResteasyJackson2Provider.ClassAnnotationKey,​com.fasterxml.jackson.jaxrs.json.JsonEndpointConfig>` | `_writers` |
    `protected ConcurrentHashMap<org.jboss.resteasy.plugins.providers.jackson.ResteasyJackson2Provider.ClassAnnotationKey,​Boolean>` | `decorators` |

    - ### Fields inherited from class com.fasterxml.jackson.jaxrs.json.JacksonJaxbJsonProvider

      `DEFAULT_ANNOTATIONS`

    - ### Fields inherited from class com.fasterxml.jackson.jaxrs.json.JacksonJsonProvider

      `_jsonpFunctionName, _providers, BASIC_ANNOTATIONS, MIME_JAVASCRIPT, MIME_JAVASCRIPT_MS`

    - ### Fields inherited from class com.fasterxml.jackson.jaxrs.base.ProviderBase

      `_cfgCheckCanDeserialize, _cfgCheckCanSerialize, _cfgCustomUntouchables, _defaultReadView, _defaultWriteView, _jaxRSFeatures, _mapperConfig, _noContentExceptionRef, _unreadableClasses, _untouchables, _unwritableClasses, CLASS_NAME_NO_CONTENT_EXCEPTION, DEFAULT_UNREADABLES, DEFAULT_UNTOUCHABLES, DEFAULT_UNWRITABLES, HEADER_CONTENT_TYPE_OPTIONS, JAXRS_FEATURE_DEFAULTS, noContentExceptionSupplier`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ResteasyJackson2Provider()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `isReadable​(Class<?> aClass, Type type, Annotation[] annotations, javax.ws.rs.core.MediaType mediaType)` |
    `boolean` | `isWriteable​(Class<?> aClass, Type type, Annotation[] annotations, javax.ws.rs.core.MediaType mediaType)` |
    `Object` | `readFrom​(Class<Object> type, Type genericType, Annotation[] annotations, javax.ws.rs.core.MediaType mediaType, javax.ws.rs.core.MultivaluedMap<String,​String> httpHeaders, InputStream entityStream)` |
    `void` | `writeTo​(Object value, Class<?> type, Type genericType, Annotation[] annotations, javax.ws.rs.core.MediaType mediaType, javax.ws.rs.core.MultivaluedMap<String,​Object> httpHeaders, OutputStream entityStream)` |

    - ### Methods inherited from class com.fasterxml.jackson.jaxrs.json.JacksonJsonProvider

      `_configForReading, _configForWriting, _locateMapperViaProvider, hasMatchingMediaType, setJSONPFunctionName, version`

    - ### Methods inherited from class com.fasterxml.jackson.jaxrs.base.ProviderBase

      `_addSuperTypes, _configForReading, _configForWriting, _containedIn, _createGenerator, _createNoContentException, _createParser, _endpointForReading, _endpointForWriting, _findCustomUntouchable, _isIgnorableForReading, _isIgnorableForWriting, _isSpecialReadable, _modifyHeaders, addUntouchable, checkCanDeserialize, checkCanSerialize, configure, configure, configure, configure, configure, disable, disable, disable, disable, disable, disable, enable, enable, enable, enable, enable, enable, findEncoding, findSuperTypes, findSuperTypes, getSize, hasMatchingMediaTypeForReading, hasMatchingMediaTypeForWriting, isEnabled, locateMapper, removeUntouchable, setAnnotationsToUse, setDefaultReadView, setDefaultView, setDefaultWriteView, setMapper`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.jboss.resteasy.core.messagebody.AsyncBufferedMessageBodyWriter

      `asyncWriteTo`

    - ### Methods inherited from interface javax.ws.rs.ext.MessageBodyWriter

      `getSize`

- - ### Field Detail

    - #### _readers

          protected final ConcurrentHashMap<org.jboss.resteasy.plugins.providers.jackson.ResteasyJackson2Provider.ClassAnnotationKey,​com.fasterxml.jackson.jaxrs.json.JsonEndpointConfig> _readers

    - #### decorators

          protected final ConcurrentHashMap<org.jboss.resteasy.plugins.providers.jackson.ResteasyJackson2Provider.ClassAnnotationKey,​Boolean> decorators

    - #### _writers

          protected final ConcurrentHashMap<org.jboss.resteasy.plugins.providers.jackson.ResteasyJackson2Provider.ClassAnnotationKey,​com.fasterxml.jackson.jaxrs.json.JsonEndpointConfig> _writers

  - ### Constructor Detail

    - #### ResteasyJackson2Provider

          public ResteasyJackson2Provider()

  - ### Method Detail

    - #### isReadable

          public boolean isReadable​(Class<?> aClass,
                                    Type type,
                                    Annotation[] annotations,
                                    javax.ws.rs.core.MediaType mediaType)

      Specified by:
        `isReadable` in interface `javax.ws.rs.ext.MessageBodyReader<Object>`
      Overrides:
        `isReadable` in class `com.fasterxml.jackson.jaxrs.base.ProviderBase<com.fasterxml.jackson.jaxrs.json.JacksonJsonProvider,​com.fasterxml.jackson.databind.ObjectMapper,​com.fasterxml.jackson.jaxrs.json.JsonEndpointConfig,​com.fasterxml.jackson.jaxrs.json.JsonMapperConfigurator>`

    - #### isWriteable

          public boolean isWriteable​(Class<?> aClass,
                                     Type type,
                                     Annotation[] annotations,
                                     javax.ws.rs.core.MediaType mediaType)

      Specified by:
        `isWriteable` in interface `javax.ws.rs.ext.MessageBodyWriter<Object>`
      Overrides:
        `isWriteable` in class `com.fasterxml.jackson.jaxrs.base.ProviderBase<com.fasterxml.jackson.jaxrs.json.JacksonJsonProvider,​com.fasterxml.jackson.databind.ObjectMapper,​com.fasterxml.jackson.jaxrs.json.JsonEndpointConfig,​com.fasterxml.jackson.jaxrs.json.JsonMapperConfigurator>`

    - #### readFrom

          public Object readFrom​(Class<Object> type,
                                 Type genericType,
                                 Annotation[] annotations,
                                 javax.ws.rs.core.MediaType mediaType,
                                 javax.ws.rs.core.MultivaluedMap<String,​String> httpHeaders,
                                 InputStream entityStream)
                          throws IOException

      Specified by:
        `readFrom` in interface `javax.ws.rs.ext.MessageBodyReader<Object>`
      Overrides:
        `readFrom` in class `com.fasterxml.jackson.jaxrs.base.ProviderBase<com.fasterxml.jackson.jaxrs.json.JacksonJsonProvider,​com.fasterxml.jackson.databind.ObjectMapper,​com.fasterxml.jackson.jaxrs.json.JsonEndpointConfig,​com.fasterxml.jackson.jaxrs.json.JsonMapperConfigurator>`
      Throws:
        `IOException`

    - #### writeTo

          public void writeTo​(Object value,
                              Class<?> type,
                              Type genericType,
                              Annotation[] annotations,
                              javax.ws.rs.core.MediaType mediaType,
                              javax.ws.rs.core.MultivaluedMap<String,​Object> httpHeaders,
                              OutputStream entityStream)
                       throws IOException

      Specified by:
        `writeTo` in interface `javax.ws.rs.ext.MessageBodyWriter<Object>`
      Overrides:
        `writeTo` in class `com.fasterxml.jackson.jaxrs.base.ProviderBase<com.fasterxml.jackson.jaxrs.json.JacksonJsonProvider,​com.fasterxml.jackson.databind.ObjectMapper,​com.fasterxml.jackson.jaxrs.json.JsonEndpointConfig,​com.fasterxml.jackson.jaxrs.json.JsonMapperConfigurator>`
      Throws:
        `IOException`